diff --git a/usr.sbin/bcmfw/README b/usr.sbin/bcmfw/README
new file mode 100644
index 0000000000..0fc59b90ee
--- /dev/null
+++ b/usr.sbin/bcmfw/README
@@ -0,0 +1,22 @@
+$FreeBSD: head/usr.sbin/bluetooth/bcmfw/README 114900 2003-05-11 02:19:10Z julian $
+
+This directory will eventually also contain copies of the broadcom firmware.
+
+It WILL look like:
+total 190
+drwxr-xr-x   3 julian  wheel     512 May 10 00:40 .
+drwxr-xr-x  11 julian  wheel     512 May 10 14:48 ..
+-rw-r--r--   1 julian  wheel     154 May 10 00:41 BCM-LEGAL.txt
+-rw-r--r--   1 julian  wheel      56 May 10 00:14 BCM2033-FW.bin.md5
+-rw-r--r--   1 julian  wheel  158049 May 10 00:14 BCM2033-FW.bin.uue
+-rw-r--r--   1 julian  wheel      56 May 10 00:14 BCM2033-MD.hex.md5
+-rw-r--r--   1 julian  wheel    4505 May 10 00:14 BCM2033-MD.hex.uue
+drwxr-xr-x   2 julian  wheel     512 May 10 00:52 CVS
+-rw-r--r--   1 julian  wheel     516 May 10 00:14 Makefile
+-rw-r--r--   1 julian  wheel    3013 May 10 00:14 bcmfw.8
+-rw-r--r--   1 julian  wheel    6806 May 10 00:14 bcmfw.c
+
+Until then, the firmware files can be fetched as part of 
+ http://bluez.sourceforge.net/download/bluez-bluefw-0.9.tar.gz
+
+
diff --git a/usr.sbin/bcmfw/bcmfw.c b/usr.sbin/bcmfw/bcmfw.c
new file mode 100644
index 0000000000..d6971d03ea
--- /dev/null
+++ b/usr.sbin/bcmfw/bcmfw.c
@@ -0,0 +1,308 @@
+/*
+ * bcmfw.c
+ *
+ * Copyright (c) 2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bcmfw.c,v 1.4 2003/04/27 19:28:09 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bcmfw/bcmfw.c 188945 2009-02-23 18:36:54Z thompsa $
+ *
+ * Based on Linux BlueZ BlueFW-0.9 package
+ *
+ */
+
+#include <sys/types.h>
+#include <sys/ioctl.h>
+#include <bus/u4b/usb.h>
+#include <bus/u4b/usb_ioctl.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <netgraph.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+
+#define BCMFW		"bcmfw"
+#define BCMFW_INTR_EP	1
+#define BCMFW_BULK_EP	2
+#define BCMFW_BSIZE	4096
+
+#define USB_VENDOR_BROADCOM 0x0a5c
+#define USB_PRODUCT_BROADCOM_BCM2033 0x2033
+
+static int bcmfw_check_device
+	(char const *name);
+static int bcmfw_load_firmware
+	(char const *name, char const *md, char const *fw);
+static void bcmfw_usage
+	(void);
+
+/*
+ * Main
+ */
+
+int
+main(int argc, char *argv[])
+{
+	char	*name = NULL, *md = NULL, *fw = NULL;
+	int	 x;
+
+	while ((x = getopt(argc, argv, "f:hn:m:")) != -1) {
+		switch (x) {
+		case 'f': /* firmware file */
+			fw = optarg;
+			break;
+
+		case 'n': /* name */
+			name = optarg;
+			break;
+
+		case 'm': /* Mini-driver */
+			md = optarg;
+			break;
+
+		case 'h':
+		default:
+			bcmfw_usage();
+			/* NOT REACHED */
+		}
+	}
+
+	if (name == NULL || md == NULL || fw == NULL)
+		bcmfw_usage();
+		/* NOT REACHED */
+
+	openlog(BCMFW, LOG_NDELAY|LOG_PERROR|LOG_PID, LOG_USER);
+
+	if (bcmfw_check_device(name) < 0)
+		exit(1);
+
+	if (bcmfw_load_firmware(name, md, fw) < 0)
+		exit(1);
+
+	closelog();
+
+	return (0);
+} /* main */
+
+/*
+ * Check device VendorID/ProductID
+ */
+
+static int
+bcmfw_check_device(char const *name)
+{
+	usb_device_descriptor_t	desc;
+	char			path[BCMFW_BSIZE];
+	int			fd = -1, error = -1;
+
+	snprintf(path, sizeof(path), "/dev/%s", name);
+
+	if ((fd = open(path, O_WRONLY)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s (%d)",
+				path, strerror(errno), errno);
+		goto out;
+	}
+
+	if (ioctl(fd, USB_GET_DEVICE_DESC, &desc) < 0) {
+		syslog(LOG_ERR, "Could not ioctl(%d, %ld, %p). %s (%d)",
+				fd, USB_GET_DEVICE_DESC, &desc,
+				strerror(errno), errno);
+		goto out;
+	}
+
+	if (UGETW(desc.idVendor) != USB_VENDOR_BROADCOM ||
+	    UGETW(desc.idProduct) != USB_PRODUCT_BROADCOM_BCM2033) {
+		syslog(LOG_ERR, "Unsupported device, VendorID=%#x, " \
+				"ProductID=%#x", UGETW(desc.idVendor),
+				UGETW(desc.idProduct));
+		error = -1;
+	} else
+		error = 0;
+out:
+	if (fd != -1)
+		close(fd);
+
+	return (error);
+} /* bcmfw_check_device */
+
+/*
+ * Download minidriver and firmware
+ */
+
+static int
+bcmfw_load_firmware(char const *name, char const *md, char const *fw)
+{
+	char	buf[BCMFW_BSIZE];
+	int	intr = -1, bulk = -1, fd = -1, error = -1, len;
+
+	/* Open interrupt endpoint device */
+	snprintf(buf, sizeof(buf), "/dev/%s.%d", name, BCMFW_INTR_EP);
+	if ((intr = open(buf, O_RDONLY)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s (%d)",
+				buf, strerror(errno), errno);
+		goto out;
+	}
+
+	/* Open bulk endpoint device */
+	snprintf(buf, sizeof(buf), "/dev/%s.%d", name, BCMFW_BULK_EP);
+	if ((bulk = open(buf, O_WRONLY)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s (%d)",
+				buf, strerror(errno), errno);
+		goto out;
+	}
+
+	/* 
+	 * Load mini-driver 
+	 */
+
+	if ((fd = open(md, O_RDONLY)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s (%d)",
+				md, strerror(errno), errno);
+		goto out;
+	}
+
+	for (;;) {
+		len = read(fd, buf, sizeof(buf));
+		if (len < 0) {
+			syslog(LOG_ERR, "Could not read(%s). %s (%d)",
+					md, strerror(errno), errno);
+			goto out;
+		}
+		if (len == 0)
+			break;
+
+		len = write(bulk, buf, len);
+		if (len < 0) {
+			syslog(LOG_ERR, "Could not write(/dev/%s.%d). %s (%d)",
+					name, BCMFW_BULK_EP, strerror(errno),
+					errno);
+			goto out;
+		}
+	}
+
+	close(fd);
+	fd = -1;
+
+	usleep(10);
+
+	/* 
+	 * Memory select 
+	 */
+
+	if (write(bulk, "#", 1) < 0) {
+		syslog(LOG_ERR, "Could not write(/dev/%s.%d). %s (%d)",
+				name, BCMFW_BULK_EP, strerror(errno), errno);
+		goto out;
+	}
+
+	if (read(intr, buf, sizeof(buf)) < 0) {
+		syslog(LOG_ERR, "Could not read(/dev/%s.%d). %s (%d)",
+				name, BCMFW_INTR_EP, strerror(errno), errno);
+		goto out;
+	}
+
+	if (buf[0] != '#') {
+		syslog(LOG_ERR, "%s: Memory select failed (%c)", name, buf[0]);
+		goto out;
+	}
+
+	/*
+	 * Load firmware
+	 */
+
+	if ((fd = open(fw, O_RDONLY)) < 0) {
+		syslog(LOG_ERR, "Could not open(%s). %s (%d)",
+				fw, strerror(errno), errno);
+		goto out;
+	}
+
+	for (;;) {
+		len = read(fd, buf, sizeof(buf));
+		if (len < 0) {
+			syslog(LOG_ERR, "Could not read(%s). %s (%d)",
+					fw, strerror(errno), errno);
+			goto out;
+		}
+		if (len == 0)
+			break;
+
+		len = write(bulk, buf, len);
+		if (len < 0) {
+			syslog(LOG_ERR, "Could not write(/dev/%s.%d). %s (%d)",
+					name, BCMFW_BULK_EP, strerror(errno),
+					errno);
+			goto out;
+		}
+	}
+
+	close(fd);
+	fd = -1;
+
+	if (read(intr, buf, sizeof(buf)) < 0) {
+		syslog(LOG_ERR, "Could not read(/dev/%s.%d). %s (%d)",
+				name, BCMFW_INTR_EP, strerror(errno), errno);
+		goto out;
+	}
+
+	if (buf[0] != '.') {
+		syslog(LOG_ERR, "%s: Could not load firmware (%c)",
+				name, buf[0]);
+		goto out;
+	}
+
+	usleep(500000);
+	error = 0;
+out:
+	if (fd != -1)
+		close(fd);
+	if (bulk != -1)
+		close(bulk);
+	if (intr != -1)
+		close(intr);
+
+	return (error);
+} /* bcmfw_load_firmware */
+
+/*
+ * Display usage message and quit
+ */
+
+static void 
+bcmfw_usage(void)
+{
+	fprintf(stdout,
+"Usage: %s -n name -m md_file -f fw_file\n"
+"Where:\n" \
+"\t-n name              device name\n" \
+"\t-m mini-driver       image mini-driver image file name for download\n" \
+"\t-f firmware image    firmware image file name for download\n" \
+"\t-h                   display this message\n", BCMFW);
+
+	exit(255);
+} /* bcmfw_usage */
+
diff --git a/usr.sbin/bt3cfw/Makefile b/usr.sbin/bt3cfw/Makefile
new file mode 100644
index 0000000000..a30b50fc12
--- /dev/null
+++ b/usr.sbin/bt3cfw/Makefile
@@ -0,0 +1,11 @@
+# $Id: Makefile,v 1.5 2003/08/14 20:06:00 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/bt3cfw/Makefile 140941 2005-01-28 16:08:11Z ru $
+
+PROG=		bt3cfw
+MAN=		bt3cfw.8
+WARNS?=		2
+
+DPADD=		${LIBNETGRAPH}
+LDADD=		-lnetgraph
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/bt3cfw/bt3cfw.c b/usr.sbin/bt3cfw/bt3cfw.c
new file mode 100644
index 0000000000..69130679a1
--- /dev/null
+++ b/usr.sbin/bt3cfw/bt3cfw.c
@@ -0,0 +1,228 @@
+/*
+ * bt3cfw.c
+ *
+ * Copyright (c) 2001 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bt3cfw.c,v 1.2 2003/05/21 22:40:29 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bt3cfw/bt3cfw.c 227876 2011-11-23 10:27:18Z kevlo $
+ */
+
+#include <sys/types.h>
+#include <errno.h>
+#include <netgraph.h>
+#include <netgraph7/bluetooth/include/ng_bt3c.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+
+#define BT3CFW_IDENT			"bt3cfw"
+#define BT3CFW_MAX_FIRMWARE_SIZE	0xffff
+
+/* Convert hex ASCII to int4 */
+static int 
+hexa2int4(const char *a)
+{
+	if ('0' <= *a && *a <= '9')
+		return (*a - '0');
+
+	if ('A' <= *a && *a <= 'F')
+		return (*a - 'A' + 0xa);
+
+	if ('a' <= *a && *a <= 'f')
+		return (*a - 'a' + 0xa);
+
+	syslog(LOG_ERR, "Invalid hex character: '%c' (%#x)", *a, *a);
+	exit(255);
+}
+
+/* Convert hex ASCII to int8 */
+static int 
+hexa2int8(const char *a)
+{
+	return ((hexa2int4(a) << 4) | hexa2int4(a + 1));
+} 
+
+/* Convert hex ASCII to int16 */
+static int 
+hexa2int16(const char *a)
+{
+	return ((hexa2int8(a) << 8) | hexa2int8(a + 2));
+} 
+
+/* Convert hex ASCII to int32 */
+static int 
+hexa2int32(const char *a)
+{
+	return ((hexa2int16(a) << 16) | hexa2int16(a + 4));
+}
+
+/* Display usage() and exit */
+static void
+usage(void)
+{
+	syslog(LOG_ERR, "Usage: %s -f FirmwareFile -n NodeName", BT3CFW_IDENT);
+	exit(255);
+}
+ 
+/* Main */
+int
+main(int argc, char *argv[])
+{
+	FILE	*firmware_file = NULL;
+	char	 buffer[80], path[NG_PATHSIZ],
+		*firmware_filename = NULL;
+	uint8_t	*firmware = NULL;
+	int	 firmware_size, opt, cs, ds;
+
+	memset(path, 0, sizeof(path));
+	openlog(BT3CFW_IDENT, LOG_NDELAY|LOG_PID|LOG_PERROR, LOG_USER);
+ 
+	while ((opt = getopt(argc, argv, "f:hn:")) != -1) {
+		switch (opt) {
+		case 'f':
+			firmware_filename = optarg;
+			break;
+  
+		case 'n':
+			snprintf(path, sizeof(path), "%s:", optarg);
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	if (firmware_filename == NULL || path[0] == 0)
+		usage();
+		/* NOT REACHED */
+
+	firmware = (uint8_t *) calloc(BT3CFW_MAX_FIRMWARE_SIZE,
+					sizeof(uint8_t));
+	if (firmware == NULL) {
+		syslog(LOG_ERR, "Could not allocate firmware buffer");
+		exit(255);
+	}
+
+	if ((firmware_file = fopen(firmware_filename, "r")) == NULL) {
+		syslog(LOG_ERR, "Could not open BT3C firmware file %s. %s (%d)",
+				firmware_filename, strerror(errno), errno);
+		exit(255);
+	}
+
+	firmware_size = 0;
+
+	while (fgets(buffer, sizeof(buffer), firmware_file)) {
+		int     i, size, address, cs, fcs;
+
+		size = hexa2int8(buffer + 2);
+		address = hexa2int32(buffer + 4);
+		fcs = hexa2int8(buffer + 2 + size * 2);
+
+		if (buffer[1] == '3') {
+			ng_bt3c_firmware_block_ep	*block = NULL;
+			uint16_t			*data = NULL;
+
+			block = (ng_bt3c_firmware_block_ep *)
+						(firmware + firmware_size);
+
+			firmware_size += sizeof(*block);
+			if (firmware_size >= BT3CFW_MAX_FIRMWARE_SIZE) {
+				syslog(LOG_ERR, "Could not add new firmware " \
+						"block. Firmware file %s is " \
+						"too big, firmware_size=%d", 
+						firmware_filename,
+						firmware_size);
+				exit(255);
+			}
+
+			block->block_address = address;
+			block->block_size = (size - 4) / 2;
+			block->block_alignment = (block->block_size * 2) % 3;
+			if (block->block_alignment != 0)
+				block->block_alignment = 3 - block->block_alignment;
+
+			firmware_size += (block->block_size * 2);
+			firmware_size += block->block_alignment;
+			if (firmware_size >= BT3CFW_MAX_FIRMWARE_SIZE) {
+				syslog(LOG_ERR, "Could not add new firmware " \
+						"data. Firmware file %s is " \
+						"too big, firmware_size=%d", 
+						firmware_filename,
+						firmware_size);
+				exit(255);
+			}
+
+			/* First part of the cheksum: size and address */
+			cs = 0;
+			for (i = 0; i < 5; i++)
+				cs += hexa2int8(buffer + 2 + i * 2);
+
+			/* Data + second part of the cheksum: data */
+			data = (uint16_t *)(block + 1);
+			for (i = 0; i < block->block_size; i++) {
+				data[i] = hexa2int16(buffer + (i * 4) + 12);
+				cs += (((data[i] & 0xff00) >> 8) & 0xff);
+				cs += (data[i] & 0x00ff);
+			}
+		} else
+			for (cs = 0, i = 0; i < size; i++)
+				cs += hexa2int8(buffer + 2 + i * 2);
+
+		if (((cs + fcs) & 0xff) != 0xff) {
+			syslog(LOG_ERR, "Invalid firmware file %s. Checksum " \
+					"error, cs=%#x, fcs=%#x, checksum=%#x",
+					firmware_filename, (cs & 0xff), fcs,
+					((cs + fcs) & 0xff));
+			exit(255);
+		}
+	}
+
+	/* Send firmware to the card */
+	if (NgMkSockNode(NULL, &cs, &ds) < 0) {
+		syslog(LOG_ERR, "Could not create Netgraph socket. %s (%d)",
+				strerror(errno), errno);
+		exit(255);
+	}
+
+	if (NgSendMsg(cs, path, NGM_BT3C_COOKIE,
+			NGM_BT3C_NODE_DOWNLOAD_FIRMWARE,
+			(void const *) firmware, firmware_size) < 0) {
+		syslog(LOG_ERR, "Could not send Netgraph message. %s (%d)",
+				strerror(errno), errno);
+		exit(255);
+	}
+
+	free(firmware);
+	firmware = NULL;
+	fclose(firmware_file);
+
+	return (0);
+}
+
diff --git a/usr.sbin/bthidcontrol/Makefile b/usr.sbin/bthidcontrol/Makefile
new file mode 100644
index 0000000000..fa25b463e9
--- /dev/null
+++ b/usr.sbin/bthidcontrol/Makefile
@@ -0,0 +1,15 @@
+# $Id: Makefile,v 1.2 2004/02/13 21:44:41 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/bthidcontrol/Makefile 128080 2004-04-10 00:18:00Z emax $
+
+.PATH:	${.CURDIR}/../bthidd
+
+PROG=		bthidcontrol
+MAN=		bthidcontrol.8
+SRCS=		bthidcontrol.c hid.c lexer.l  parser.y sdp.c
+WARNS?=		1
+CFLAGS+=	-DBTHIDCONTROL=1 -I${.CURDIR}/../bthidd
+
+DPADD=		${LIBBLUETOOTH} ${LIBSDP} ${LIBUSBHID}
+LDADD=		-lbluetooth -lsdp -lusbhid
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/bthidcontrol/bthidcontrol.c b/usr.sbin/bthidcontrol/bthidcontrol.c
new file mode 100644
index 0000000000..8ed7503101
--- /dev/null
+++ b/usr.sbin/bthidcontrol/bthidcontrol.c
@@ -0,0 +1,215 @@
+/*
+ * bthidcontrol.c
+ *
+ * Copyright (c) 2004 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bthidcontrol.c,v 1.2 2004/02/13 21:44:41 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidcontrol/bthidcontrol.c 163811 2006-10-31 00:26:58Z markus $
+ */
+
+#include <sys/queue.h>
+#include <assert.h>
+#include <bluetooth.h>
+#include <err.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <usbhid.h>
+#include "bthid_config.h"
+#include "bthidcontrol.h"
+
+static int do_bthid_command(bdaddr_p bdaddr, int argc, char **argv);
+static struct bthid_command * find_bthid_command(char const *command, struct bthid_command *category);
+static void print_bthid_command(struct bthid_command *category);
+static void usage(void);
+
+int32_t hid_sdp_query(bdaddr_t const *local, bdaddr_t const *remote, int32_t *error);
+
+uint32_t verbose = 0;
+
+/*
+ * bthidcontrol
+ */
+
+int
+main(int argc, char *argv[])
+{
+	bdaddr_t	bdaddr;
+	int		opt;
+
+	hid_init(NULL);
+	memcpy(&bdaddr, NG_HCI_BDADDR_ANY, sizeof(bdaddr));
+
+	while ((opt = getopt(argc, argv, "a:c:H:hv")) != -1) {
+		switch (opt) {
+		case 'a': /* bdaddr */
+			if (!bt_aton(optarg, &bdaddr)) {
+				struct hostent  *he = NULL;
+
+				if ((he = bt_gethostbyname(optarg)) == NULL)
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
+
+				memcpy(&bdaddr, he->h_addr, sizeof(bdaddr));
+			}
+			break;
+
+		case 'c': /* config file */
+			config_file = optarg;
+			break;
+
+		case 'H': /* HIDs file */
+			hids_file = optarg;
+			break;
+
+		case 'v': /* verbose */
+			verbose++;
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	argc -= optind;
+	argv += optind;
+
+	if (*argv == NULL)
+		usage();
+
+	return (do_bthid_command(&bdaddr, argc, argv));
+} /* main */
+
+/* Execute commands */
+static int
+do_bthid_command(bdaddr_p bdaddr, int argc, char **argv)
+{
+	char			*cmd = argv[0];
+	struct bthid_command	*c = NULL;
+	int			 e, help;
+
+	help = 0;
+	if (strcasecmp(cmd, "help") == 0) {
+		argc --;
+		argv ++;
+
+		if (argc <= 0) {
+			fprintf(stdout, "Supported commands:\n");
+			print_bthid_command(sdp_commands);
+			print_bthid_command(hid_commands);
+			fprintf(stdout, "\nFor more information use " \
+					"'help command'\n");
+
+			return (OK);
+		}
+
+		help = 1;
+		cmd = argv[0];
+	}
+
+	c = find_bthid_command(cmd, sdp_commands); 
+	if (c == NULL)
+		c = find_bthid_command(cmd, hid_commands); 
+
+	if (c == NULL) {
+		fprintf(stdout, "Unknown command: \"%s\"\n", cmd);
+		return (ERROR);
+	}
+
+	if (!help)
+		e = (c->handler)(bdaddr, -- argc, ++ argv);
+	else
+		e = USAGE;
+
+	switch (e) {
+	case OK:
+	case FAILED:
+		break;
+
+	case ERROR:
+		fprintf(stdout, "Could not execute command \"%s\". %s\n",
+				cmd, strerror(errno));
+		break;
+
+	case USAGE:
+		fprintf(stdout, "Usage: %s\n%s\n", c->command, c->description);
+		break;
+
+	default: assert(0); break;
+	}
+
+	return (e);
+} /* do_bthid_command */
+
+/* Try to find command in specified category */
+static struct bthid_command *
+find_bthid_command(char const *command, struct bthid_command *category)
+{ 
+	struct bthid_command	*c = NULL;
+  
+	for (c = category; c->command != NULL; c++) {
+		char	*c_end = strchr(c->command, ' ');
+  
+		if (c_end != NULL) {
+			int	len = c_end - c->command;
+ 
+			if (strncasecmp(command, c->command, len) == 0)
+				return (c);
+		} else if (strcasecmp(command, c->command) == 0)
+				return (c);
+	}
+  
+	return (NULL);
+} /* find_bthid_command */
+
+/* Print commands in specified category */
+static void
+print_bthid_command(struct bthid_command *category)
+{
+	struct bthid_command	*c = NULL;
+ 
+	for (c = category; c->command != NULL; c++)
+		fprintf(stdout, "\t%s\n", c->command);
+} /* print_bthid_command */
+
+/* Usage */ 
+static void
+usage(void)
+{
+	fprintf(stderr,
+"Usage: bthidcontrol options command\n" \
+"Where options are:\n"
+"	-a bdaddr	specify bdaddr\n" \
+"	-c file		specify path to the bthidd config file\n" \
+"	-H file		specify path to the bthidd HIDs file\n" \
+"	-h		display usage and quit\n" \
+"	-v		be verbose\n" \
+"	command		one of the supported commands\n");
+	exit(255);
+} /* usage */
+
diff --git a/usr.sbin/bthidcontrol/bthidcontrol.h b/usr.sbin/bthidcontrol/bthidcontrol.h
new file mode 100644
index 0000000000..be9afdb6e2
--- /dev/null
+++ b/usr.sbin/bthidcontrol/bthidcontrol.h
@@ -0,0 +1,50 @@
+/*
+ * bthidcontrol.h
+ *
+ * Copyright (c) 2004 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: bthidcontrol.h,v 1.1 2004/02/12 23:25:51 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidcontrol/bthidcontrol.h 128080 2004-04-10 00:18:00Z emax $
+ */
+
+#ifndef __BTHIDCONTROL_H__
+#define __BTHIDCONTROL_H__
+
+#define OK			0	/* everything was OK */
+#define ERROR			1	/* could not execute command */
+#define FAILED			2	/* error was reported */
+#define USAGE			3	/* invalid parameters */
+
+struct bthid_command {
+	char const		*command;
+	char const		*description;
+	int			(*handler)(bdaddr_t *, int, char **);
+};
+
+extern struct bthid_command	hid_commands[];
+extern struct bthid_command	sdp_commands[];
+
+#endif /* __BTHIDCONTROL_H__ */
+
diff --git a/usr.sbin/bthidcontrol/hid.c b/usr.sbin/bthidcontrol/hid.c
new file mode 100644
index 0000000000..2d8fbaf8dc
--- /dev/null
+++ b/usr.sbin/bthidcontrol/hid.c
@@ -0,0 +1,214 @@
+/*
+ * hid.c
+ *
+ * Copyright (c) 2004 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: hid.c,v 1.3 2004/02/17 22:14:57 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/bthidcontrol/hid.c 163811 2006-10-31 00:26:58Z markus $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <bus/u4b/usb.h>
+#include <bus/u4b/usbhid.h>
+#include <stdio.h>
+#include <string.h>
+#include <usbhid.h>
+#include "bthid_config.h"
+#include "bthidcontrol.h"
+
+extern uint32_t verbose;
+
+static void hid_dump_descriptor	(report_desc_t r);
+static void hid_dump_item	(char const *label, struct hid_item *h);
+
+static int
+hid_dump(bdaddr_t *bdaddr, int argc, char **argv)
+{
+	struct hid_device	*hd = NULL;
+	int			 e = FAILED;
+
+	if (read_config_file() == 0) {
+		if ((hd = get_hid_device(bdaddr)) != NULL) {
+			hid_dump_descriptor(hd->desc);
+			e = OK;
+		} 
+
+		clean_config();
+	}
+
+	return (e);
+}
+
+static int
+hid_forget(bdaddr_t *bdaddr, int argc, char **argv)
+{
+	struct hid_device	*hd = NULL;
+	int			 e = FAILED;
+
+	if (read_config_file() == 0) {
+		if (read_hids_file() == 0) {
+			if ((hd = get_hid_device(bdaddr)) != NULL) {
+				hd->new_device = 1;
+				if (write_hids_file() == 0)
+					e = OK;
+			}
+		}
+
+		clean_config();
+	}
+
+	return (e);
+}
+
+static int
+hid_known(bdaddr_t *bdaddr, int argc, char **argv)
+{
+	struct hid_device	*hd = NULL;
+	struct hostent		*he = NULL;
+	int			 e = FAILED;
+
+	if (read_config_file() == 0) {
+		if (read_hids_file() == 0) {
+			e = OK;
+
+			for (hd = get_next_hid_device(hd);
+			     hd != NULL;
+			     hd = get_next_hid_device(hd)) {
+				if (hd->new_device)
+					continue;
+
+				he = bt_gethostbyaddr((char *) &hd->bdaddr,
+						sizeof(hd->bdaddr),
+						AF_BLUETOOTH);
+
+				fprintf(stdout,
+"%s %s\n",				bt_ntoa(&hd->bdaddr, NULL),
+					(he != NULL && he->h_name != NULL)?
+						he->h_name : "");
+			}
+		}
+
+		clean_config();
+	}
+
+	return (e);
+}
+
+static void
+hid_dump_descriptor(report_desc_t r)
+{
+	struct hid_data	*d = NULL;
+	struct hid_item	 h;
+
+	for (d = hid_start_parse(r, ~0, -1); hid_get_item(d, &h); ) {
+		switch (h.kind) {
+		case hid_collection:
+			fprintf(stdout,
+"Collection page=%s usage=%s\n", hid_usage_page(HID_PAGE(h.usage)),
+				 hid_usage_in_page(h.usage));
+			break;
+
+		case hid_endcollection:
+			fprintf(stdout, "End collection\n");
+			break;
+
+		case hid_input:
+			hid_dump_item("Input  ", &h);
+			break;
+
+		case hid_output:
+			hid_dump_item("Output ", &h);
+			break;
+
+		case hid_feature:
+			hid_dump_item("Feature", &h);
+			break;
+		}
+	}
+
+	hid_end_parse(d);
+}
+
+static void
+hid_dump_item(char const *label, struct hid_item *h)
+{
+	if ((h->flags & HIO_CONST) && !verbose)
+		return;
+
+	fprintf(stdout,
+"%s id=%u size=%u count=%u page=%s usage=%s%s%s%s%s%s%s%s%s%s",
+		label, (uint8_t) h->report_ID, h->report_size, h->report_count,
+		hid_usage_page(HID_PAGE(h->usage)),
+		hid_usage_in_page(h->usage),
+		h->flags & HIO_CONST ? " Const" : "",
+		h->flags & HIO_VARIABLE ? " Variable" : "",
+		h->flags & HIO_RELATIVE ? " Relative" : "",
+		h->flags & HIO_WRAP ? " Wrap" : "",
+		h->flags & HIO_NONLINEAR ? " NonLinear" : "",
+		h->flags & HIO_NOPREF ? " NoPref" : "",
+		h->flags & HIO_NULLSTATE ? " NullState" : "",
+		h->flags & HIO_VOLATILE ? " Volatile" : "",
+		h->flags & HIO_BUFBYTES ? " BufBytes" : "");
+
+	fprintf(stdout,
+", logical range %d..%d",
+		h->logical_minimum, h->logical_maximum);
+
+	if (h->physical_minimum != h->physical_maximum)
+		fprintf(stdout,
+", physical range %d..%d",
+			h->physical_minimum, h->physical_maximum);
+
+	if (h->unit)
+		fprintf(stdout,
+", unit=0x%02x exp=%d", h->unit, h->unit_exponent);
+
+	fprintf(stdout, "\n");
+}
+
+struct bthid_command	hid_commands[] = {
+{
+"Dump",
+"Dump HID descriptor for the specified device in human readable form. The\n" \
+"device must have an entry in the Bluetooth HID daemon configuration file.\n",
+hid_dump
+},
+{
+"Known",
+"List all known to the Bluetooth HID daemon devices.\n",
+hid_known
+},
+{
+"Forget",
+"Forget (mark as new) specified HID device. This command is useful when it\n" \
+"is required to remove device from the known HIDs file. This should be done\n" \
+"when reset button was pressed on the device or the battery was changed. The\n"\
+"Bluetooth HID daemon should be restarted.\n",
+hid_forget
+},
+{ NULL, NULL, NULL }
+};
+
